#include "hbdyn.ch"

/* compile: hbmk2 jeffbase -b -gtwvt */


PROCEDURE Main
   LOCAL hDLL
   LOCAL xResult
   LOCAL StrToSet := SPACE( 64 )  /* long enough buffer for result by reference */
   LOCAL i

   ALTD()
   ? "Before DLL loaded"
   hDLL := hb_libLoad( "jeff_dll.dll" )
   IF ! Empty( hDLL )
      ? "DLL has been loaded"
      xResult := hb_DynCall( { "fpimport0", hDLL, hb_bitOr( HB_DYN_CTYPE_CHAR_PTR , HB_DYN_CALLCONV_CDECL ) }, "TESTHB0" )
      ? "fpimport0 to TESTHB0 called <", xResult, ">"

      FOR i := 1 TO 10000
         xResult := hb_DynCall( { "fpimport1", hDLL, hb_bitOr( HB_DYN_CTYPE_CHAR_PTR , HB_DYN_CALLCONV_CDECL ) } , "TESTHB1", @StrToSet )
         IF i == 1
            ? "fpimport1() to TESTHB1 called, result by @:", RTRIM( StrToSet )
            ? "xResult = ", xResult
         ENDIF
      NEXT i
  
      hb_libFree( hDLL )
   ENDIF
RETURN